c---------------------------------------------------------------------
      subroutine input0(epsj,Vtautau,knmin,knmax,tgmass,
     &  EFL,difm,nqmax,q_int_min,dq_int,
     &  w_int_min,dw_int,IRUMAX,KTLTR,obex)
c      input for continuum rpa
c---------------------------------------------------------------------
c  parameter command for the dimensions
      include 'dimn.fh'
c  common blocks
      include 'ndp.fh'
      include 'fund1.fh'
      include 'fund2.fh'
      include 'base.fh'
      include 'numrun.fh'
      include 'cntl.fh'
      include 'opep.fh'
      include 'gprtrm.fh'
      include 'hprtrm.fh'
      include 'opta1.fh'
      include 'opta2.fh'
      include 'orbt.fh'
c
      dimension KTOPTN(10)
      dimension a(8)
c=============================================================
c  Prefixed parameters
C==============================================================
      real*8 AMU/931.494043d0/      !Atomic mass unit
      real*8 mproton/938.2731d0/    !Proton mass
      real*8 mneutron/939.56563d0/  !Neutron mass
      REAL*8 MN_AV/938.91937d0/     !Average nucleon mass
      real*4 mDelta/1236.0/         !Delta mass
ccc      real*4 mDelta/1232.0/         !Delta mass
c
      data pz  /0.0,1.0,0.0,1.0,-1.0, 0.0, 1.0, 2.0 /
      data pspn/0.5,0.5,0.5,0.5, 1.5, 1.5, 1.5, 1.5 /
      data istr/0,1/         !transferred spins
      data pspn1/0.5,0.5/    !projectile and ejectile spins
c-------------------------------------------------------------------
      difm = mDelta-MN_AV
      pmas(1)=mneutron/AMU
      pmas(2)=mproton/AMU
      pmas(3)=pmas(1)
      pmas(4)=pmas(2)
      do i=5,8
         pmas(i)=mDelta/AMU
      end do
      epsj=0.005  !response function convergence criterion 
c====================================================================
c   Date, run numer and title
c====================================================================
c     numrun(1):day, 
c     numrun(2):month, 
c     numrun(3):year,
c     numrun(4):run number
c     ititle   :title 
C======================================================================
      read(1,'(2i2,i4,i2)',end=9000) (numrun(i),i=1,4)
      read(1,'(20a4)') ititle
C======================================================================
C  Calculation Options
c=====================================================================
c      KTRPA : = 0 : 0th
C              = 1 : TDA
c              = 2 : RPA
c              = 3 : RPA for p-h but TDA for Delta-h 
c      KTND    = 0 : without Delta
c              = 1 : with Delta
c      KTRQCV  = 0 : No convergence check 
c              = 1 : Convergence check by RS(q), RL(q) and RT(q)
c              = 2 : Convergence chech by RS(q)
c              = 3 : Convergence check by RL(q) and RT(q)
c      KTVEFF  = 0 : only LM-term in effective interaction
c              = 1 : LM+OBEP in effective interaction
C      KTHSPWD = 0 : No spreading widths of holes
C              = 1 : With spreading widths of holes
c
c      IRUMAX : maximum no. of RPA, 0th control
c        IRU=1: 0th, IRU=2: with correlation
c
c      0nly p-h            : NDPMAX = 1,NDMMAX = 1,ICHMX =4 (KTND=0)
c      Both p-h and Delta-h: NDPMAX = 2,NDMMAX = 3,ICHMX =8 (KTND=1)
C======================================================================
C  Output Options
C=====================================================================
c     KTOUT_VEF: OUTPUT effective interaction
c           =0: No output
c           =1: Output Effective Interaction
c     KTOUT_BDW: Print bound state wave functions 
c           =N in step N of KTOUT_BDW
c           =0: Not printing
C=====================================================================
      read(1,'(10i1)') ktoptn
c---------------------------------------------------------------------
        KTRPA = KTOPTN(1)
        KTND  = KTOPTN(2)
        KTRQCV= KTOPTN(3)
        KTVEFF= KTOPTN(4)
        KTHSPWD= KTOPTN(5)
c
        KTOUT_VEF =KTOPTN(6)
        KTOUT_BDW =KTOPTN(7)
c
      if(KTRPA.eq.0) then
        IRUMAX=1
      else
        IRUMAX=2
      endif
c
       NDPMIN=1
       if(KTND.eq.0) then
         NDPMAX=1
         NDMMAX=1
         ICHMX =4
       else if(KTND.eq.1) then
         NDPMAX=2
         NDMMAX=3
         ICHMX =8
       end if
c
      if(KTVEFF.eq.0) obex = 0.0
      if(KTVEFF.eq.1) obex = 1.0
C======================================================================
c   Read page
c----------------------------------------------------------------------
 2000 read(1,'(8f10.5)') (a(i),i=1,8)
 4000 i=a(1)+0.1
      fi=i
      ich=(a(1)-fi)*10.0+0.01
c======================================================================
C     PAGE 01: Reaction specification
c      projectile and ejectile are the proton or the neutron 
c      Atg  : target mass number
c      Ztg  : target charge
c      Zprj : projectile charge
c      Zejc : ejectile   charge
c      itrz  : transferred charge
C======================================================================
      if(i.eq.1) then
        Atg   = a(2)
        Ztg   = a(3)
        itrz  = a(4)
c
        tgmass= AMU*Atg
c
        do iii=1,2
           tmas(iii)=Atg-1.0
           tz(iii)= Ztg-pz(iii)
           pztz(iii)=pz(iii)*tz(iii)
        end do
        do iii=3,8
           tmas(iii)=Atg-1.0
           tz(iii)= Ztg+itrz-pz(iii)
           pztz(iii)=pz(iii)*tz(iii)
        end do
c
        tz1(1)  =Ztg
C======================================================================
C     PAGE 02:
c      q_int_min: minimum of q_int.(1/fm)
c      dq_int : increment of q_int.(1/fm)
c      nqmax : number of q_int
c      W_int_min: minimum omega_int (MeV) 
c      dw_int: increment of omega_int (MeV))
c      nwmax : number of omega_int
c      omegd: table of transferred omega_int
C======================================================================
      else if(i.eq.2) then
        nqmax    =a(2)
        q_int_min=a(3)
        dq_int   =a(4)
c
        nwmax =a(5)
        w_int_min  =a(6)
        dw_int=a(7)
        do nw = 1,nwmax
            omegd(nw)=w_int_min+(nw-1)*dw_int
        end do
C======================================================================
C     PAGE 03: Transferred quantities
c--------------------------------------------------------------------- 
c      total spin transfer
c        itrjmn: minimum J,  
c        itrjmx: maximum J
c      parity transfer
c        knmin : parity transfer minimum
c        knmax : parity transfer maxmum
c         kn = 1: natural parity excitation
c         kn = 2: unnatural parity excitation
c      Orbital angular momentum transfer(special option)
c         KTLTR = 0: Standard choice
c         KTLTR = 1: Only lowest Ltr for the given Jtr   
c      Convergence check with respect to Jtr
c         EPSJ : Convergence check criterion
C                If it is 0.0, it is set to be 0.005 (default)    
c      Intrinsic energy transfer modification
Cccccc         WSHIFT: Energy shift for response function
C======================================================================
      else if(i.eq.3) then
        itrjmn=a(2)
        itrjmx=a(3)
        knmin =a(4)
        knmax =a(5) 
        KTLTR =a(6)
        IF(a(7).ne.0.0) EPSJ  =a(7)
C======================================================================
C     PAGE 04: integration data
c       rmax  : maximum r 
c       nsrmax: number of mesh points in response func. calculation
c       nrmax= 2*nsrmax: number of mesh points in wave func. calculation
c       tkdmx : maximum momentum k for Fourier transform (fm-1)
c       nkmax : number of mesh points of k
C======================================================================
      else if(i.eq.4) then
        rmax=a(2)
        nsrmax= a(3)+0.1
        tkdmx=a(4)
        nkmax=a(5)+0.1
        if(nsrmax.gt.nsrdm) write(*,*)
     &     ' nsrmax exceeds NSRDM. Stop in input0'
        if(nkmax.gt.nkdm) write(*,*)
     &     ' nkmax exceeds NKDM. Stop in input0'
C
        dsr  =rmax/nsrmax
        dr=dsr/2.0
        nrmax=2*nsrmax
C======================================================================
C     PAGE 05: single particle potential(real part)
c       ICH =1: n-hole, =2: p-hole, =3: n-part, =4: p-part, =5: Delta   
C======================================================================
      else if(i.eq.5) then
        vd(ich)  =a(2)
        rrd(ich) =a(3)
        ard(ich) =a(4)
c
        vsod(ich)=a(5)
        rsod(ich)=a(6)
        asod(ich)=a(7)
c
        rcd(ich) =a(8)
C======================================================================
C     PAGE  6: Single particle potential(imaginary part)
c       ICH =1: n-hole, =2: p-hole, =3: n-part, =4: p-part, =5: Delta   
c       ICH=1,2: fixed by fxpotR.f 
C======================================================================
      else if(i.eq.6) then
        wd(ich)   =a(2)
        rid(ich)  =a(3)
        aid(ich)  =a(4)
        WV0(ich)  =a(5)
        WS0(ich)  =a(6)
        RVD2(ICH) =A(7)
        AVD2(ICH) =A(8)
C======================================================================
C     PAGE  7: EFFECTIVE MASS AND SPREADING WIDTH PARAMETERS 
c     reffd(ich):radius      parameter of effective mass form factor
c     aeffd(ich):diffuseness parameter of effective mass form factor
c     bdifd(ich):strength    parameter of effective mass form factor
c     alphsw(ich): spreading width strength    
c     eps0sw(ich): spreading width parameter 1 
c     eps1sw(ich): spreading width parameter 2 
C     ICH=1,2,3,4
C======================================================================
      ELSE IF(I.EQ.7) THEN
        REFFD(ICH) = A(2)
        AEFFD(ICH) = A(3)
        BDIFD(ICH) = A(4)
        alphsw(ich)= a(5)
        eps0sw(ich)= a(6)
        eps1sw(ich)= a(7)
C======================================================================
C     PAGE 8: Occupied single particle states
c     nspmx(ich) : no. of   occupied single particle states
c---------------------------------------------------------------------
c     nspd  : n 
c     lspd  : l
c     fjspd : j,
c     berspd: real part of binding energy
C======================================================================
      else if(i.eq.8) then
        nspmx(ich)=a(2)+0.1
c---------------------------------------------------------------------
        do n=1,nspmx(ich)
          read(1,'(2i5,2f10.5)') nspd(n,ich),lspd(n,ich),
     1                 FJSPD(N,ICH),BERSPD(N,ICH)
        end do
C======================================================================
C     PAGE 09: Effective Interaction of isovector channel
c----------------------------------------------------------------------
c     Vtautau : effective interaction strength of tautau-term 
c               with delta-type (MeV.fm^3)
c     piNN(D) coupling 
c       facbs   = (f_piNN)^2/(4*Pi) : pi-NN coupling constant
c       fratio  = f_piND/f_piNN
c       epion   : pion mass
c       wdthpi  : width of the pion popagator
c
c     piNN(D)  vertex form factor
c       ctpi(1) : Cutoff mass for piNN in MeV
c       nctpi(1): Exponent of piNN vertex
c       ctpi(2) : Cutoff mass for piND in MeV
c       nctpi(2): Exponent of piND vertex
c     rhoNN(D) coupling 
c       crhoo = [(f_rhoNN/f_piNN)/(m_rho/m_pi)]^2
c             = [(f_rhoND/f_piND)/(m_rho/m_pi)]^2 (assumed)
c       erhoo   : rho-meson mass
c       wdthrh  : width of rho propagator
c     rhoNN(D) vertex form factor
c       ctrh(1) : Cutoff mass for rhoNN in MeV
c       nctrh(1): Exponent of rhoNN vertex
c       ctrh(2) : Cutoff mass for rhoND in MeV
c       nctrh(2): Exponent of rhoND vertex
c
c     Landau-Migdal parameters
c
c      gpr-term factor
c       gpr(1,1)=g'_NN, gpr(1,2)=gpr(2,1)=g'_ND, gpr(2,2)=g'_DD     
c       ctgpr   : Cutoff mass for g' form factor in MeV
c       nctgpr  : Exponent of g' form factor
c
c      hpr-term factor
c       hpr(1,1)=h'_NN, hpr(1,2)=hpr(2,1)=h'_ND, hpr(2,2)=h'_DD
c       cthpr   : Cutoff mass for h' form factor in MeV
c       ncthpr  : Exponent of h' form factor
C======================================================================
      else if(i.eq.9) then
          if(ich.eq.0)  then
             Vtautau = a(2)
          else if(ich.eq.1)  then
            facbs  = a(2)
            fratio = a(3)
            crhoo  = a(4)
c
          else if(ich.eq.2)  then
            epion   = a(2)
            wdthpi  = a(3)
            ctpi(1) = a(4)
            nctpi(1)= a(5) + 0.1
            ctpi(2) = a(6)
            nctpi(2)= a(7) + 0.1
c
          else if(ich.eq.3)  then
            erhoo   = a(2)
            wdthrh  = a(3)
            ctrh(1) = a(4)
            nctrh(1)= a(5) + 0.1
            ctrh(2) = a(6)
            nctrh(2)= a(7) + 0.1
c
          else if(ich.eq.4)  then
            gpr(1,1) = a(2)
            gpr(1,2) = a(3)
            gpr(2,1) = a(3)
            gpr(2,2) = a(4)
            ctgpr = a(5)
            nctgpr= a(6) + 0.1
c
          else if(ich.eq.5)  then
            hpr(1,1) = a(2)
            hpr(1,2) = a(3)
            hpr(2,1) = a(3)
            hpr(2,2) = a(4)
            cthpr = a(5)
            ncthpr= a(6) + 0.1
c
          endif
C======================================================================
C     PAGE 0: read stop 
c       Go to setting remaining parameters
C======================================================================
      else if(i.eq.0) then
C======================================================================
c  set p-h/Delta-h state specification
c---------------------------------------------------------------------
        call phspec(itrz,KTRPA,KTND,npairx,ipsd1,ipsd2,fbck)
c======================================================================
c  Subside Potential Data 
c--------------------------------------------------------------------- 
        call fxpotR
c======================================================================
        return
C-------------------------------------------------------------------
      end if
C====================================================================
      goto 2000
C--------------------------------------------------------------------
 9000 stop
      end
