c======================================================================
      PROGRAM MAIN
c   CONTINUUM RPA CALCULATION
c======================================================================
c       cnvcm     : convergence check index for RS
c       cnvvm,    : convergence check index for RV
c======================================================================
      include 'dimn.fh'
      include 'ndp.fh'
      include 'fund1.fh'
      include 'fund2.fh'
      include 'cntl.fh'
      include 'opep.fh'
      include 'space.fh'
      include 'grpaj.fh'
      include 'veffct.fh'
      include 'rsrtrl.fh'
      include 'base.fh'
      include 'lgbs.fh'
      include 'weff.fh'
c
      real*4 wgt(nrdm)
      integer Jconv(nwdm)
      complex bzero(nsrdm*2*2,nsrdm*2*2,2,2,2,2)
      complex tzffr(2,nsrdm*2,nsrdm*2,2,2,2,2)
c
      real*8 cpi/3.141592654d0/
C======================================================================
c  *** INPUT 
      CALL INPUT0(epsj,Vtautau,knmin,knmax,tgmass,
ccccc     &  EFL,WSHIFT,difm,nqmax,q_int_min,dq_int,
     &  EFL,difm,nqmax,q_int_min,dq_int,
     &  w_int_min,dw_int,IRUMAX,KTLTR,obex)
C======================================================================
C   *** OUTPUT INPUT DATA
      CALL WRITE0(EPSJ,Vtautau,knmin,knmax,tgmass,
ccccc     &  EFL,WSHIFT,nqmax,q_int_min,dq_int,w_int_min,dw_int,
     &  EFL,nqmax,q_int_min,dq_int,w_int_min,dw_int,
     &  KTLTR,obex)
C=====================================================================
C   *** SET WEIGHT OF RADIAL INTEGRATION (SIMPSON'S INTEGRAL)
      CALL WEIGHT(wgt,dsr,nsrmax,nrdm)      
c======================================================================
C   *** LEGENDRE-GAUSS MESH POINTS & SHPERICAL BESSEL FUNC. ***
      CALL LGSBSL
C===================================================================
C   *** WOODS-SAXON BOUND STATE W.F.: ci(nr,(sp.no1,sp.no2)) ***
      CALL BOUND
      CALL WBOUND(KTOUT_BDW,NRMAX) 
C==================================================================
C   PREPARE FACLOG(N)=LOG((N-1)!)
      call stfclg
C==================================================================
C====================================================================
c   DO LOOP OF intrinsic transfferd momentum q_int
c====================================================================
      do 6000 nq=1,nqmax
      q_int = q_int_min+(nq-1)*dq_int
C====================================================================
c   DO LOOP OF Transferred intrinsic energy OMEGA
c====================================================================
      do 5000 nw=1,nwmax
      omeg  = omegd(nw)
c===================================================================
C   INITIALIZATION of grpa2
      do NDM=1,3
         do jtr=1,itrjmx
            do ip=1,2
               do kls=1,4
                  grpa2(jtr,ip,kls,NDM)=(0.0,0.0)
               end do
            end do
         end do
      end do
c=====================================================================
C   INITIALIZATION of RPS,RPV,RPL
         rps(nw)=0.0
         do NDM=1,3
            rpl(nw,NDM) =0.0
            rpv(nw,NDM)=0.0
         end do
c=====================================================================
C   *** Effective interaction in q representation ***
      if(KTRPA.ne.0) then
         CALL  weffq(wefflq,wefftq,omeg,NDPMIN,NDPMAX,nkmax,
     &               fkdmsh,nkdm,obex) 
      end if
c======================================================================
c   { DO LOOP of ITRJ (transfer J)
c---------------------------------------------------------------------
      do 1000 itrjd=itrjmn,itrjmx
C----------------------------------------------------------------------
C    { DO LOOP OF PARITY
c     ip = 1: natural parity
c        = 2: unnatural parity
c----------------------------------------------------------------------
        do 980 ip=knmin,knmax
          iparit=ip
          kltrmx=ip
          if(KTLTR.eq.1)  kltrmx=1
          ltr(1)=itrjd-(ip-1)
          ltr(2)=itrjd+(ip-1)
          kstrmn=ip
          kstrmx=2
          if(itrjd.eq.0) then
            kltrmx=1
            ltr(1)=ip-1
            ltr(2)=ip-1
            kstrmx=ip
          end if
c
        ndmax=nsrmax*kltrmx
c
C       *** EFFECTIVE POTENTIAL: vff((r1,l1),(r2,l2)) ***
          if(KTRPA.ne.0) then
            CALL VEFFSV(itrjd,omeg,vff,wefflq,wefftq)
          endif
C----------------------------------------------------------------
C       *** p-h GREEN'S FUNC.: bzero((r1,l1),(r2,l2)) ***
          CALL SLFZR(itrjd,omeg,ndmax,difm,bzero)
C----------------------------------------------------------------
C   POLARIZATION PROPAGATER: tzffr((r1,l1),(r2,l2)) 
C
      do KNDP2=1,2
      do KNDP1=1,2
        do Kist2=1,2
        do Kist1=1,2
          do Kn2=1,2*nsrdm
          do Kn1=1,2*nsrdm
            do KIRU=1,2
              tzffr(KIRU,Kn1,Kn2,Kist1,Kist2,KNDP1,KNDP2)=(0.0,0.0)
            end do
          end do  
          end do
        end do
        end do
      end do
      end do
C
C   DO LOOP OF TRANSFERRED SPIN 
      do 190 ist2=kstrmn,kstrmx
      do 180 ist1=kstrmn,kstrmx
c
c   NO CORRELATION
       do iru=1,irumax
       CALL NONRPA(ist1,ist2,tzffr,iru,ndmax,NDPMIN,NDPMAX,bzero,nsrdm)
       end do
C
C   WITH CORRELATIONS
        if(KTRPA.ne.0) then
C    ISOVECTOR SPIN-SCALAR CHANNEL
          if(ist1.eq.1.and.ist2.eq.1) then
          call coupless(nsrdm,nsrmax,dsr,tzffr,bzero,wgt,Vtautau)
C    ISOVECTOR SPIN-VECTOR CHANNEL
          else if(ist1.eq.2.and.ist2.eq.2) then
           CALL COUPLESV(ndmax,tzffr,vff,bzero,wgt,
     &           NDPMIN,NDPMAX,nsrmax)
          endif
        endif
C
  180 continue ! End of transferred spin do loop (s1)
  190 continue ! End of transferred spin do loop (s2)
C===================================================================   
C  Polarization Propagator IN q REPRESENTATION
C   DIAGONAL PART: grpa2(j,pi,l1,s1,l2,s2,q,w;U/C)
C------------------------------------------------------------------ 
        CALL GQQ(itrjd,q_int,wgt,tzffr,grpa2,
     &           IRUMAX,NDPMIN,NDPMAX,nsrmax,dsr)
c--------------------------------------------------------------------
  980 CONTINUE  ! End of parity do loop
C===================================================================   
C  RESPONSE FUNCTIONS IN q REPRESENTATION
c-------------------------------------------------------------------- 
         itrjmx1=itrjd
           call  RSRTRL(nw,grpa2,itrjd,cnvcm,cnvvm,cnvlm,NDMMAX)
C-------------------------------------------------------------------
C  Convergence Check with respect to transferred J sum
            if(KTRQCV.eq.0) go to 1000
            if(KTRQCV.eq.1) cnv=max(cnvcm,cnvvm)
            if(KTRQCV.eq.2) cnv=cnvcm
            if(KTRQCV.eq.3) cnv=cnvvm
            if((cnv.ge.epsj/1000.0).and.(cnv.le.epsj)) then
               Jconv(nw)=itrjd
               goto 2000
            else
               Jconv(nw)=0
            end if
C=====================================================================
 1000 CONTINUE  !End of Jtr do loop
 2000 continue  !Exit point after Convergence Check
 5000 continue  !End of omega do loop
c===================================================================
C  OUTPUT CONVERGENCE CHECK INFORMATION AND RESPONSE FUNCTIONS
C-----------------------------------------------------------------
C   OUTPUT CONVERGENCE CHECK INFORMATION
        if(KTRQCV.ne.0) then
         call  WCONV(Jconv,nwmax,omegd,q_int)
        end if
C===================================================================
C  Calculate full response functions and sum rule values and
C  Output them
C-------------------------------------------------------------------
        CALL WRSRTRL(q_int,fratio,omegd,dw_int,NDMMAX,nwmax,KTRPA)
c==================================================================
 6000 continue  !End of angle do loop
c==================================================================
 9999 stop
      end
